; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm

; 
    .data
      buff db 20 dup(0)
    .code
; 

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; BINary to DECimal conversion using multiplies.  Assume unsigned numbers.
; The number in AX is printed to the console as five digits.  Actually,
; works with all five digit numbers.

; 21 Sep Start word logic.  Which didn't work.
; 23 September 2008, start double word version.

;   INPUT:  AX or low half of EAX contains the 16 bit number to be
;           converted to decimal ASCII.
;    Uses:  EAX, ECX, EDX
;   Calls:  SCALL CONOUT, macro to write DL to standard output.

Bin2DecM:
        push ebx
        mov ebx, OFFSET buff

        AND     EAX,0000FFFFH   ; Optional safety check, limit to 16 bits.
        MOV     EDX,00068DB9H   ; Multiplier to get leading decimal digit
                                ; into low byte of EDX (DL).
        MUL     EDX     ; Do a fixed point 16:16 x 16:16 multiply to get
                        ; a 32:32 result.

        PUSH    EAX
        ADD     DL,'0'  ; Convert binary to ASCII.
        ;SCALL   CONOUT  ; Print leading decimal digit.

        mov [ebx], dl

        POP     EAX     ; And restore fraction.

        MOV     ECX,10  ; Multiplier to get remaining digits.

        MUL     ECX     ; Second digit.

        PUSH    EAX
        ADD     DL,'0'
        ;SCALL   CONOUT

        mov [ebx+1], dl

        POP     EAX

        MUL     ECX     ; And repeat as necessary.

        PUSH    EAX
        ADD     DL,'0'
        ;SCALL   CONOUT

        mov [ebx+2], dl

        POP     EAX

        MUL     ECX

        PUSH    EAX
        ADD     DL,'0'
        ;SCALL   CONOUT

        mov [ebx+3], dl

        POP     EAX

        MUL     ECX

        ADD     DL,'0'
        ;SCALL   CONOUT   ; Final digit
        mov [ebx+4], dl

        pop ebx

        RET

; 
start:
; 

    mov eax, 65535
    call Bin2DecM
    print ADDR buff,13,10

    mov eax, 65534
    call Bin2DecM
    print ADDR buff,13,10

    mov eax, 1
    call Bin2DecM
    print ADDR buff,13,10

    mov eax, 0
    call Bin2DecM
    print ADDR buff,13,10,13,10

    invoke Sleep, 3000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      mov eax, 12345
      call Bin2DecM
    counter_end
    print ustr$(eax)," cycles, Bin2DecM",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke dwtoa, 12345, ADDR buff
    counter_end
    print ustr$(eax)," cycles, dwtoa",13,10,13,10

    inkey "Press any key to exit..."
    exit
; 
end start
